diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObjectSolved.java b/src/main/java/org/distorted/objectlib/main/TwistyObjectSolved.java
index 73c2758f..248d0bb8 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyObjectSolved.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObjectSolved.java
@@ -119,7 +119,7 @@ class TwistyObjectSolved
 // Color index, i.e. the index into the 'FACE_COLORS' table.
 // else (edge or corner cubit, more than one non-black face): return -2.
 
-  private int retCubitSolvedStatus(int cubit, int[] numLayers, int numCubitFaces, int[][] cubitFaceColors)
+  private int retCubitSolvedStatus(int cubit, int[] numLayers, int numCubitFaces)
     {
     int numNonBlack=0, nonBlackIndex=-1, stiShape, cubColor;
     int variant = mParent.getCubitVariant(cubit,numLayers);
@@ -127,8 +127,7 @@ class TwistyObjectSolved
     for(int face=0; face<numCubitFaces; face++)
       {
       stiShape = mParent.getVariantStickerShape(variant,face);
-      int numFaces = cubitFaceColors[cubit].length;
-      cubColor = face<numFaces ? cubitFaceColors[cubit][face] : -1;
+      cubColor = mParent.getCubitFaceMap(cubit,face);
 
       if( stiShape>=0 && cubColor>=0 )
         {
@@ -600,7 +599,7 @@ class TwistyObjectSolved
 // Called from TwistyObject
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int[][] getSolvedQuats(int[] numLayers, int numCubitFaces, int[][] cubitFaceColors)
+  int[][] getSolvedQuats(int[] numLayers, int numCubitFaces)
     {
     int[] groups = new int[mNumCubits];
     int numGroups = 1;
@@ -608,7 +607,7 @@ class TwistyObjectSolved
 
     for(int cubit=0; cubit<mNumCubits; cubit++)
       {
-      groups[cubit] = retCubitSolvedStatus(cubit,numLayers,numCubitFaces,cubitFaceColors);
+      groups[cubit] = retCubitSolvedStatus(cubit,numLayers,numCubitFaces);
       if( groups[cubit]>=0 ) numGroups++;
       else                   numFirst++;
       }
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObjectTheoretical.java b/src/main/java/org/distorted/objectlib/main/TwistyObjectTheoretical.java
index 64761565..7ecc56c8 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyObjectTheoretical.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObjectTheoretical.java
@@ -1,5 +1,5 @@
 ///////////////////////////////////////////////////////////////////////////////////////////////////
-// Copyright 2020 Leszek Koltunski                                                               //
+// Copyright 2024 Leszek Koltunski                                                               //
 //                                                                                               //
 // This file is part of Magic Cube.                                                              //
 //                                                                                               //
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObjectWithMesh.java b/src/main/java/org/distorted/objectlib/main/TwistyObjectWithMesh.java
new file mode 100644
index 00000000..fa3a0cf6
--- /dev/null
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObjectWithMesh.java
@@ -0,0 +1,490 @@
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// Copyright 2024 Leszek Koltunski                                                               //
+//                                                                                               //
+// This file is part of Magic Cube.                                                              //
+//                                                                                               //
+// Magic Cube is proprietary software licensed under an EULA which you should have received      //
+// along with the code. If not, check https://distorted.org/magic/License-Magic-Cube.html        //
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+package org.distorted.objectlib.main;
+
+import org.distorted.library.effect.MatrixEffectMove;
+import org.distorted.library.effect.MatrixEffectQuaternion;
+import org.distorted.library.effect.VertexEffectQuaternion;
+import org.distorted.library.effect.VertexEffectSink;
+import org.distorted.library.helpers.QuatHelper;
+import org.distorted.library.main.DistortedEffects;
+import org.distorted.library.mesh.MeshBase;
+import org.distorted.library.mesh.MeshFile;
+import org.distorted.library.mesh.MeshJoined;
+import org.distorted.library.type.Static1D;
+import org.distorted.library.type.Static3D;
+import org.distorted.library.type.Static4D;
+import org.distorted.objectlib.helpers.FactoryCubit;
+import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectVertexEffects;
+import org.distorted.objectlib.helpers.OperatingSystemInterface;
+import org.distorted.objectlib.metadata.Metadata;
+
+import java.io.DataInputStream;
+import java.io.IOException;
+import java.io.InputStream;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+public abstract class TwistyObjectWithMesh extends TwistyObjectTheoretical
+  {
+  public static final float SQ2 = (float)Math.sqrt(2);
+  public static final float SQ3 = (float)Math.sqrt(3);
+  public static final float SQ5 = (float)Math.sqrt(5);
+  public static final float SQ6 = (float)Math.sqrt(6);
+
+  protected static final Static3D CENTER = new Static3D(0,0,0);
+
+  protected int[] mNumLayers;
+  protected MeshBase mMesh;
+  protected DistortedEffects mEffects;
+  protected int mNumCubitFaces;
+
+  private Static4D[] mCubitOrigQuat;
+  private MeshBase[] mMeshes;
+  private Static4D[] mMixupModeQuats;
+  private boolean mIsInMixupMode;
+  private ObjectShape[] mShapes;
+  private int mNumCubitVariants;
+  private int[][] mCubitFaceColors;
+  private int[][] mVariantFaceIsOuter;
+  private int mMaxNumLayers;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  void initialize(InitAssets asset, boolean fromJSON)
+    {
+    Static3D[] axis = getRotationAxis();
+    int[][] angles = getBasicAngles();
+    Static3D[] faceAxis = getFaceAxis();
+    float[][] positions = getCubitPositions(mNumLayers);
+    float[][] cuts = getCuts(mNumLayers);
+    int[][] minCubits = getMinimalCubiesInRow();
+
+    int numCubits = positions.length;
+    float[][] offsets = new float[numCubits][];
+    int[] types = new int[numCubits];
+
+    for(int c=0; c<numCubits; c++)
+      {
+      offsets[c] = getCubitRowOffset(c);
+      types[c] = getCubitRotationType(c);
+      }
+
+    super.initialize(axis, angles, positions, cuts, minCubits, offsets, types, faceAxis);
+
+    mCubitOrigQuat = new Static4D[mNumCubits];
+    for(int i=0; i<mNumCubits; i++) mCubitOrigQuat[i] = getCubitQuats(i,mNumLayers);
+
+    mMaxNumLayers = -1;
+    for(int i=0; i<mNumAxis; i++)
+      {
+      if( mMaxNumLayers<mNumLayers[i] ) mMaxNumLayers = mNumLayers[i];
+      }
+
+    mEffects = new DistortedEffects();
+    createQuaternionEffects();
+
+    InputStream meshStream = asset!=null ? asset.getMeshStream(): null;
+    boolean fromDMESH = (meshStream!=null);
+    getShapes(fromDMESH,fromJSON);
+    createWholeMesh(meshStream,fromDMESH);
+
+    for(int c=0; c<mNumCubits; c++) setCubitQuat(c,0);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void createQuaternionEffects()
+    {
+    if( mNumQuats<=ObjectControl.MAX_QUATS )
+      {
+      mIsInMixupMode = false;
+
+      for( int q=0; q<mNumQuats; q++)
+        {
+        VertexEffectQuaternion vq = new VertexEffectQuaternion(mObjectQuats[q],CENTER);
+        vq.setMeshAssociation(0,q);
+        mEffects.apply(vq);
+        }
+      }
+    else if( mNumCubits<=ObjectControl.MAX_QUATS )
+      {
+      mIsInMixupMode = true;
+      mMixupModeQuats = new Static4D[mNumCubits];
+
+      for( int q=0; q<mNumCubits; q++)
+        {
+        mMixupModeQuats[q] = new Static4D(mObjectQuats[0]);
+        VertexEffectQuaternion vq = new VertexEffectQuaternion(mMixupModeQuats[q],CENTER);
+        vq.setMeshAssociation(0,q);
+        mEffects.apply(vq);
+        }
+      }
+    else
+      {
+      android.util.Log.e("D", "object has too many quaternions ("+mNumQuats+") or too many cubits ("+mNumCubits+")");
+      }
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private Static3D getPos(float[] origPos)
+    {
+    int len = origPos.length/3;
+    float sumX = 0.0f;
+    float sumY = 0.0f;
+    float sumZ = 0.0f;
+
+    for(int i=0; i<len; i++)
+      {
+      sumX += origPos[3*i  ];
+      sumY += origPos[3*i+1];
+      sumZ += origPos[3*i+2];
+      }
+
+    sumX /= len;
+    sumY /= len;
+    sumZ /= len;
+
+    return new Static3D(sumX,sumY,sumZ);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void createOuterFaces()
+    {
+    for(int v=0; v<mNumCubitVariants; v++)
+      {
+      int numFaces = mShapes[v].getNumFaces();
+      mVariantFaceIsOuter[v] = new int[numFaces];
+      }
+
+    for( int cubit=0; cubit<mNumCubits; cubit++)
+      {
+      int variant = getCubitVariant(cubit,mNumLayers);
+      int numFaces = mShapes[variant].getNumFaces();
+
+      for(int face=0; face<numFaces; face++)
+        if( getCubitFaceMap(cubit,face)>=0 ) mVariantFaceIsOuter[variant][face] = 1;
+      }
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void getShapes(boolean fromDMESH, boolean fromJSON)
+    {
+    mNumCubitVariants = getNumCubitVariants(mNumLayers);
+
+    if( fromJSON ) mNumCubitFaces = getNumCubitFaces();
+
+    if( !fromDMESH || !fromJSON )
+      {
+      FactoryCubit factory = FactoryCubit.getInstance();
+      factory.clear();
+
+      mShapes = new ObjectShape[mNumCubitVariants];
+      for(int v=0; v<mNumCubitVariants; v++) mShapes[v] = getObjectShape(v);
+      mNumCubitFaces = ObjectShape.computeNumComponents(mShapes);
+      mVariantFaceIsOuter = new int[mNumCubitVariants][];
+
+      if( !fromJSON )
+        {
+        mCubitFaceColors = ObjectShape.computeColors(mShapes,mCubitPos, mCubitOrigQuat,this);
+        createOuterFaces();
+        }
+
+      if( fromDMESH )
+        {
+        for(int i=0; i<mNumCubitVariants; i++) factory.createNewFaceTransform(mShapes[i], mVariantFaceIsOuter[i]);
+        }
+      }
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void createWholeMesh(InputStream stream, boolean fromDMESH)
+    {
+    if( fromDMESH )
+      {
+      DataInputStream dos = new DataInputStream(stream);
+      mMesh = new MeshFile(dos);
+
+      try
+        {
+        stream.close();
+        }
+      catch(IOException e)
+        {
+        android.util.Log.e("meshFile", "Error closing InputStream: "+e);
+        }
+      }
+    else
+      {
+      MeshBase[] cubitMesh = new MeshBase[mNumCubits];
+
+      for(int i=0; i<mNumCubits; i++)
+        {
+        cubitMesh[i] = createSingleCubitMesh(i,mNumLayers,mNumCubitFaces);
+        Static3D pos = getPos(mCubitPos[i]);
+        cubitMesh[i].apply(new MatrixEffectMove(pos),1,0);
+        }
+
+      mMesh = new MeshJoined(cubitMesh);
+
+      float pillowCoeff = getPillowCoeff();
+
+      if( pillowCoeff!=1.0f )
+        {
+        float radius = getCircumscribedRadius();
+        Static1D coeff = new Static1D(pillowCoeff);
+        Static4D region= new Static4D(0,0,0,radius);
+        VertexEffectSink sink = new VertexEffectSink(coeff,CENTER,region);
+        mMesh.apply(sink);
+        }
+      }
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private MeshBase createSingleCubitMesh(int cubit, int[] numLayers, int numComponents)
+    {
+    int variant = getCubitVariant(cubit,numLayers);
+
+    if( mMeshes==null ) mMeshes = new MeshBase[mNumCubitVariants];
+
+    if( mMeshes[variant]==null )
+      {
+      ObjectFaceShape faceShape = getObjectFaceShape(variant);
+      ObjectVertexEffects effects = getVertexEffects(variant);
+      FactoryCubit factory = FactoryCubit.getInstance();
+      factory.createNewFaceTransform(mShapes[variant],mVariantFaceIsOuter[variant]);
+      mMeshes[variant] = factory.createRoundedSolid(mShapes[variant],faceShape,effects,numComponents);
+      }
+
+    MeshBase mesh = mMeshes[variant].copy(true);
+    MatrixEffectQuaternion quat = new MatrixEffectQuaternion( mCubitOrigQuat[cubit], CENTER );
+    mesh.apply(quat,0xffffffff,0);
+
+    return mesh;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  void rotateAllCubits(int axisIndex, int rowBitmap, int angle)
+    {
+    super.rotateAllCubits(axisIndex,rowBitmap,angle);
+    for(int i=0; i<mNumCubits; i++) setCubitQuat(i,getCubitQuatIndex(i));
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getCubitFaceMap(int cubit, int face)
+    {
+    int numFaces = mCubitFaceColors[cubit].length;
+    int puzzleFace = face<numFaces ? mCubitFaceColors[cubit][face] : -1;
+    return puzzleFace<0 ? -1 : puzzleFace;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// this would return the REAL value of outer; the 'getCubitFaceColor()>=0' returns if the face is
+// colored, which for example in case of Container (which has colored internal faces) is not the
+// same thing
+
+  boolean faceIsOuter(int cubit, int face)
+    {
+    if( mCubitFaceColors==null )
+      {
+      if( mShapes   ==null ) mShapes = new ObjectShape[mNumCubitVariants];
+      if( mShapes[0]==null ) for(int v=0; v<mNumCubitVariants; v++) mShapes[v] = getObjectShape(v);
+
+      if( mCubitOrigQuat   ==null ) mCubitOrigQuat = new Static4D[mNumCubits];
+      if( mCubitOrigQuat[0]==null ) for(int c=0; c<mNumCubits; c++) mCubitOrigQuat[c] = getCubitQuats(c,mNumLayers);
+
+      mCubitFaceColors = ObjectShape.computeColors(mShapes,mCubitPos, mCubitOrigQuat,this);
+      }
+
+    return mCubitFaceColors[cubit][face]>=0;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  void releaseResources()
+    {
+    super.releaseResources();
+    mMesh.markForDeletion();
+    mEffects.markForDeletion();
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void setCubitQuat(int cubit, int equAssociation)
+    {
+    int andAssociation=0, accumulativeShift=0;
+
+    for(int axis=0; axis<mNumAxis; axis++)
+      {
+      int rotRow = getCubitRotRow(cubit,axis);
+      andAssociation += (rotRow<<accumulativeShift);
+      accumulativeShift += mMaxNumLayers;
+      }
+
+    if( !mIsInMixupMode )
+      {
+      mMesh.setEffectAssociation(cubit,andAssociation,equAssociation);
+      }
+    else
+      {
+      mMesh.setEffectAssociation(cubit,andAssociation,cubit);
+      Static4D tmp = mObjectQuats[equAssociation];
+      mMixupModeQuats[cubit].set(tmp);
+      }
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// Return the 'surface' the given face of the given cubit is on. (px,py,pz) is the pre-computed
+// center of the cubit (so we don't have to keep re-computing this per each face)
+// If the face is not external, return null.
+//
+// This is needed by the TwistyObjectSolved's method2 detecting if the object is in a solved state.
+//
+// What is a 'surface' ? For objects with flat monochromatic external walls, it is simply a 4-tuple
+// [(nx,ny,nz),d] (normal vector + distance from origin) describing a 3D plane this face is part of.
+// Exceptions are objects with curved external walls (ATM Masterball & Penrose Cubes): it is a union
+// of several surfaces which together define the bent, monochromatic wall. I.e. Penrose Cube has 3
+// surfaces (blue, yellow and red), each defined by 3 planes (think before the bending effect!)
+//
+// This is the default which simply returns the single plane. If some puzzle has more complicated
+// surfaces, it needs to override this method.
+//
+// We never need to test if a given point is part of a given surface (see TwistyObjectSurface!) - we
+// only need to be able to rotate the surface by quats and test if two surfaces are the same. Thus:
+// it is possible to provide some artificial surfaces - for example, in case of the Penrose, the
+// three surfaces can be only the single 'middle' plane [the one on the bend].
+
+  public float[] getMonochromaticSurface(int variant, int cubitIndex, int faceIndex, float px, float py, float pz)
+    {
+    if( !faceIsOuter(cubitIndex,faceIndex) ) return null;
+
+    Static4D cubitQuat = getCubitQuats(cubitIndex,mNumLayers);
+
+    float[] normal   = new float[4];
+    float[] intPoint = new float[3];
+    float[] rotPoint = new float[4];
+    float[] surface  = new float[4];
+
+    ObjectShape objShape = mShapes[variant];
+    objShape.getFacePoint(faceIndex,intPoint);
+    objShape.getFaceNormal(faceIndex,normal);
+
+    QuatHelper.rotateVectorByQuat(rotPoint,intPoint[0],intPoint[1],intPoint[2],1,cubitQuat);
+    QuatHelper.rotateVectorByQuat(surface,normal[0],normal[1],normal[2],0,cubitQuat);
+
+    float x = rotPoint[0] + px;
+    float y = rotPoint[1] + py;
+    float z = rotPoint[2] + pz;
+    surface[3] = x*surface[0] + y*surface[1] + z*surface[2];
+
+    return surface;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  boolean restorePreferences(String key, OperatingSystemInterface os)
+    {
+    boolean error = super.restorePreferences(key,os);
+
+    if( error )
+      {
+      for(int c=0; c<mNumCubits; c++) setCubitQuat(c,0);
+      }
+    else
+      {
+      for(int c=0; c<mNumCubits; c++)
+        {
+        int q = getCubitQuatIndex(c);
+        setCubitQuat(c, q);
+        }
+      }
+
+    return error;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// Radius of the sphere circumscribed on the puzzle. Needed for pillowing.
+//
+// This won't work correctly for pillowing off-center puzzles (e.g. mirrors) - for those we'd need
+// to introduce the concept of a 'sink center' as well.
+//
+// public because needed in TouchControlShapemod
+
+  public float getCircumscribedRadius()
+    {
+    float size = getSize();
+
+    switch( getCategory() )
+      {
+      case Metadata.CATEGORY_SHAPE_TET: return (SQ6/4)*size;
+      case Metadata.CATEGORY_SHAPE_HEX: return (SQ3/2)*size;
+      case Metadata.CATEGORY_SHAPE_OCT: return (SQ2/2)*size;
+      case Metadata.CATEGORY_SHAPE_DOD: return (SQ3/2)*((SQ5+1)/2)*size;
+      case Metadata.CATEGORY_SHAPE_BAL: return 0.50f*size;
+      case Metadata.CATEGORY_SHAPE_ICO: return 0; // no pillowed icosahedra
+      case Metadata.CATEGORY_SHAPE_BAR: return 0; // no pillowed barrels
+      }
+
+    return 0.0f;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// INTERNAL API - those are called from 'effects' package
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public MeshBase getObjectMesh()            { return mMesh; }
+  public DistortedEffects getObjectEffects() { return mEffects; }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// PUBLIC API
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public synchronized void solve()
+    {
+    super.solve();
+    for(int i=0; i<mNumCubits; i++) setCubitQuat(i,0);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public float getPillowCoeff()                     { return 1.0f; }
+  public int[][] getMinimalCubiesInRow()            { return null; }
+  public int[] getNumLayers()                       { return mNumLayers; }
+  public int getCubitRotationType(int cubit)        { return TwistyObjectTheoreticalCubit.TYPE_NORMAL; }
+  public float[] getCubitRowOffset(int cubitIndex)  { return null; }
+  public int[][] getVariantFaceIsOuter()            { return mVariantFaceIsOuter; }
+  public int getNumCubitFaces()                     { return 0; }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public abstract Static3D[] getFaceAxis();
+  public abstract float[][] getCuts(int[] numLayers);
+  public abstract int getCubitVariant(int cubit, int[] numLayers);
+  public abstract ObjectShape getObjectShape(int variant);
+  public abstract ObjectFaceShape getObjectFaceShape(int variant);
+  public abstract ObjectVertexEffects getVertexEffects(int variant);
+  public abstract int getNumCubitVariants(int[] numLayers);
+  public abstract float[][] getCubitPositions(int[] numLayers);
+  public abstract Static4D getCubitQuats(int cubit, int[] numLayers);
+  public abstract Static3D[] getRotationAxis();
+  public abstract int[][] getBasicAngles();
+  public abstract int getCategory();
+  public abstract float[] getDist3D(int[] numLayers);
+  public abstract float getSize();
+  }
